target= triangle formule proba

#if TARGET_triangle
\title{Complter le triangle de Pascal}
\observation{A complter, quatre valeurs d'une ligne. De faon quiprobable : au dbut, au milieu ou  la fin}
\language{fr}
\range{-5..5}
\author{Bruno, Mifsud}
\email{communaute.mutuwims@laposte.net}
\computeanswer{no}
\format{html}
\precision{10000}
#endif

#if TARGET_formule
\title{Utilisation de la formule}
#endif
#if TARGET_proba
\title{Calcul d'une probabilit}
#endif


#if TARGET_formule || TARGET_proba 
\language{fr}
\range{-5..5}
\author{Chantal, Causse}
\email{Chantal.Causse@noos.fr}
\computeanswer{no}
\format{html}
\precision{10000}
#endif

#if TARGET_triangle
\integer{q00=12}%%%% pour avoir toutes les donnes
\integer{derligne=randint(5..\q00-2)}
%%%% premier nombre  complter
\integer{quest=random(1,\derligne-1,randint(2..\derligne-2))}
%%%%%
#endif
%%%%%%%% MB %%%%%%%%%%%%%%%%
Limite du nombre de rptition
\text{confparm2=\confparm2 issametext ?20:\confparm2}
Affichage du triangle 
\text{confparm3=\confparm3 issametext ?0:\confparm3}
%%%%%%%%%%
#if TARGET_proba
\integer{n=random(5..\confparm2)}
\real{p=randint(2..10)/100}
\real{q = 1-\p}
\real{cp = 100*\p}
\real{cq = 100*\q}
%%%%% MB taille du triangle  afficher
\integer{q00=\n+random(1,2,3)}
%%%%%%%
#endif

#if TARGET_formule
\integer{n=random(5..\confparm2)}
%%%%% MB taille du triangle  afficher
\integer{q00=\n+random(1,2)}
%%%%%%%
#endif


\matrix{triangle=1;1,1;1,2,1}
\for{n00=4 to \q00}{
\for{k00=1 to \n00}{
\if{\k00=1}{\matrix{triangle=\triangle;1}
}{\if{\k00=\n00}{\matrix{triangle=\triangle,1}}
{\matrix{triangle=\triangle,simplify(\triangle[\n00-1;\k00-1]+\triangle[\n00-1;\k00])}
}}}}

\text{affichagetriangle=(\confparm3=1) and (\confparm2=10)?<div class="wims_instruction">On donne &#58; \([\triangle]) </div>:}
\text{affichagetrianglefeedback=(\confparm3=1) and (\confparm2=10)?<div class="wims_instruction">Rappel &#58; \([\triangle]) </div>:}

#if TARGET_triangle

\text{listestep=wims(makelist reply x for x=\quest to \quest+3)}
\steps{\listestep}
\matrix{affichage=row(1..\derligne+1,\triangle)}
#endif
#if TARGET_proba
\real{p=randint(2..10)/100}
\real{q = 1-\p}
\real{cp = 100*\p}
\real{cq = 100*\q}

#endif


#if TARGET_proba
%%%% modif MB
\integer{n=\confparm2=10 ? random(5..10):random(5..20)}
%%%%%% fin modif MB
\real{p=randint(2..10)/100}
\real{q = 1-\p}
\real{cp = 100*\p}
\real{cq = 100*\q}


\integer{choix=random(1,2)}
\text{succ=item(\choix, pices acceptables, pices dfectueuses)}
\text{ech= item(3-\choix, pices acceptables, pices dfectueuses)}
\rational{psucc = item(\choix,\q,\p)}
\rational{pech = item(3-\choix,\q,\p)}

\text{probas=}
\for{i=0 to \n}{
\text{probas= \probas,slib(stat/binomialpdf \i,\n,\psucc)}
}

\text{probac=}
\for{i=0 to \n}{
\text{probac= \probac,slib(stat/binomialcdf \i,\n,\psucc)}
}

\integer{min = 0}
\integer{max = \n}

\if{\choix=1}{
\while{\probas[\min+2] < 0.0002}{\integer{min= \min + 1}}
\integer{max = \n}
}

\if{\choix=2}{
\while{\probas[\max+2] < 0.0002}{\integer{max= \max - 1}}
\integer{min = 0}
}

\integer{k1 = random(\min..\max)}
\integer{kk1 = \n - \k1}

\text{pk= slib(stat/binomialpdf \k1,\n,\psucc)}
\text{pk=floor(10000*\pk +0.5)/10000}

\text{\enonce1= random(
\cp % des pices fabriques par une machine sont dfectueuses,
La probabilit qu'une pice soit acceptable est \q,
Une machine produit des pices avec un pourcentage de \cq % de pices acceptables,
On tire au hasard une pice dans la production d'une machine. La probabilit qu'elle soit dfectueuse est \p
) }
\text{\enonce2=random(exactement \k1 \succ, exactement \kk1 \ech,
\k1 \succ, \kk1 \ech)}

%%%% modif MB pour les s dans les cas k1 et kk1 qui valent 0 ou 1
%%%% si accept il faudra supprimer les lignes prcdentes qui dfinissent enonce2
\integer{rand8=randint(1..4)}
\text{enonce2=exactement \k1 \succ, exactement \kk1 \ech, \k1 \succ, \kk1 \ech}
\text{enonce2=\enonce2[\rand8]}
\if{\rand8=1 or \rand8=3}{\if{\k1=1 or \k1=0}{
\text{enonce2=wims(replace internal pices acceptables by pice acceptable in \enonce2)}
\text{enonce2=wims(replace internal pices dfectueuses by pice dfectueuse in \enonce2)}
}}
\if{\rand8=2 or \rand8=4}{\if{\kk1=1 or \kk1=0}{
\text{enonce2=wims(replace internal pices acceptables by pice acceptable in \enonce2)}
\text{enonce2=wims(replace internal pices dfectueuses by pice dfectueuse in \enonce2)}
}}

%%%% pour feedback MB
\real{pksol=\pk}
\integer{k=\k1}
\integer{coeffnk=binomial(\n,\k1)}
\integer{k11=\k1+1}
#endif
#if TARGET_formule
\real{p=randint(1..99)/100}
\real{q = 1-\p}

\text{probas=}
\for{i=0 to \n}{
\text{probas= \probas,slib(stat/binomialpdf \i,\n,\p)}
}

\text{probac=}
\for{i=0 to \n}{
\text{probac= \probac,slib(stat/binomialcdf \i,\n,\p)}
}

\integer{min = 0}
\integer{max = \n}
\while{\probas[\min+2] < 0.0002}{\integer{min= \min + 1}}
\while{\probas[\max+2] < 0.0002}{\integer{max= \max - 1}}

\integer{k = random(\min..\max)}

\text{pk= slib(stat/binomialpdf \k,\n,\p)}
\text{pk=floor(10000*\pk +0.5)/10000}
%%%%%% MB
\real{pksol=\pk}
\integer{coeffnk=binomial(\n,\k)}
\integer{k11=\k+1}
#endif
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% statements %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#if TARGET_triangle
\statement{<div class="wims_question">Complter ci-dessous l'extrait du triangle de Pascal :
<div class="wimscenter">
<table class="wimsborder">
\for{j=\derligne-3 to \derligne+1}{<tr>
\for{i=max(1,\quest-1) to \quest+3}{<td>\triangle[\j;\i]</td>}
</tr>}
<tr>
\if{\quest>1}{<td>\triangle[\derligne+2;\quest-1]</td>}
\for{rep=\quest to \quest+3}{<td>\embed{reply \rep,5}</td>}
</tr>
</table>
</div>
</div>}
#endif

#if TARGET_formule
\statement{On considre une variable alatoire \(X\) qui suit la loi binomiale
\(B)(\n ; \p).
<div class="wims_question"><label for="reply1">Calculer  \(10^-4) prs :\(p(X = \k)) = </label>\embed{reply1,8}.</div>

\affichagetriangle
}
#endif
#if TARGET_proba
\statement{\enonce1.
<p>On appelle \(X\) la variable alatoire qui,  tout chantillon de \n pices prleves
avec remise,
associe le nombre de \succ dans cet chantillon.
La variable alatoire \(X\) suit donc la loi binomiale \(B)(\n ; \psucc).</p>
<div class="wims_question">Calculer  \(10^-4) prs la <label for="reply1">probabilit d'avoir dans cet chantillon
\enonce2 : </label>\embed{reply1,8}.</div>
\affichagetriangle
}
#endif

%%%%%%%%%%%%%%%%%%%%%%%%%%%%% answers %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#if TARGET_triangle
\answer{}{\triangle[\derligne+2;1]}{type=numeric}
\answer{}{\triangle[\derligne+2;2]}{type=numeric}
\answer{}{\triangle[\derligne+2;3]}{type=numeric}
\answer{}{\triangle[\derligne+2;4]}{type=numeric}
\answer{}{\triangle[\derligne+2;5]}{type=numeric}
\answer{}{\triangle[\derligne+2;6]}{type=numeric}
\answer{}{\triangle[\derligne+2;7]}{type=numeric}
\answer{}{\triangle[\derligne+2;8]}{type=numeric}
\answer{}{\triangle[\derligne+2;9]}{type=numeric}
\answer{}{\triangle[\derligne+2;10]}{type=numeric}
\answer{}{\triangle[\derligne+2;11]}{type=numeric}
\answer{}{\triangle[\derligne+2;12]}{type=numeric}
#endif


#if TARGET_formule ||TARGET_proba
\answer{}{\pk}{type=numeric}
#endif


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%feedback %%%%%%%%%%
#if TARGET_triangle
\text{screp=\sc_reply1,\sc_reply2,\sc_reply3,\sc_reply4,\sc_reply5,\sc_reply6,\sc_reply7,
\sc_reply8,\sc_reply9,\sc_reply10,\sc_reply11,\sc_reply12}
\text{test=items(position(1,\screp))}
\feedback{\test<4}{<div class="feedback">
Rappel : 
<ul><li>Chaque ligne commence par un 1</li>
<li>Chaque ligne finit par un 1</li>
<li>Les autres valeurs s'obtiennent par addition (voir exemple ci dessous)</li>
</ul>
<table class="wimsborder">
\for{jc=\derligne-3 to \derligne}{<tr>
\for{ic=max(1,\quest-1) to \quest+3}{<td>
\triangle[\jc;\ic]
</td>}
</tr>}
<tr>
\if{\quest>1}{<td>\triangle[\derligne+1;\quest-1]</td>}
<td><b>\triangle[\derligne+1;\quest]</b></td>
<td><b>\triangle[\derligne+1;\quest+1]</b></td>
<td>\triangle[\derligne+1;\quest+2]</td>
<td>\triangle[\derligne+1;\quest+3]</td>
</tr>
<tr>
\if{\quest>1}{<td>\triangle[\derligne+2;\quest-1]</td>}
<td>\triangle[\derligne+2;\quest]</td>
<td>\triangle[\derligne+2;\quest+1]=\triangle[\derligne+1;\quest]+\triangle[\derligne+1;\quest+1]</td>
<td>\triangle[\derligne+2;\quest+2]</td>
<td>\triangle[\derligne+2;\quest+3]</td>
</tr>
</table>
</div>}
#endif

#if TARGET_formule || TARGET_proba
\feedback{\sc_reply1<1}{<div class="feedback">
<strong>Rappel :</strong>  pour une variable alatoire \(X\) qui suit la loi binomiale
\(B(n ; p)\), \(p(X = k)) = \([n;k]\)\(p^{k} (1-p)^{n-k}\) o \([n;k]\) est le nombre de chemins qui contiennent \(k\) 
succs parmi les \(n) rptitions. 
<p>
Ici : \(p(X = \k)) = \([\n;\k]\)\(\p^{\k} (1-\p)^{\n-\k}\). \([\n;\k]=\coeffnk\) en utilisant une calculatrice ou  partir du 
triangle de Pascal.
</p>
<P>En calculant on obtient : \(p(X = \k)= \pksol\)  \(10^-4) prs.
</p>
\if{\confparm3=1}{\([\n;\k]=\coeffnk\) est le coefficient numro \(\k11\) de la ligne du triangle 
de Pascal qui commence par \(1) puis \(\n\).}
\affichagetrianglefeedback
</div>

}
#endif
